import java.net.*;
import java.io.*;
JSONArray values;
String result;
//OPENMAPS

//result of the string from the URL

//Create mercator map object
MercatorMap mercatorMap;

//create PVector
PVector zone;

PImage chicago;

void setup() {
  //size comes from TileMill or image size
  //  size(400, 516);
  orientation(PORTRAIT);
  size(displayWidth, displayHeight);

  result   = getUrlContents("https://data.cityofchicago.org/resource/i8y3-ytj4.json");

  //println(json);//or save it?
  //load the image object
  chicago = loadImage("chicago2.png");

  //create the map/sketch coordinate translation
  //need to make sure in top lat, bottom lat, left long, right lat (NSWE) -- 
  //TileMill gives L long, bottom lat, right long, top lat
  //  mercatorMap = new MercatorMap(400, 516, 42.04, 41.63, -87.92, -87.49);
  mercatorMap = new MercatorMap(displayWidth, displayHeight, 42.02, 41.70, -87.90, -87.44);
  //  textAlign(CENTER, CENTER);
  //  ellipseMode(CENTER);
  //  rectMode(CENTER);
  //    
  JSONArray json = JSONArray.parse(result);
}


void draw() {
  image(chicago, 0, 0, width, height);


  JSONArray json = JSONArray.parse(result); //URL

  for (int i = 0; i < json.size (); i++) {

    JSONObject farmersmarket = json.getJSONObject(i);

    Float lat = farmersmarket.getFloat("latitude");

    Float lon = farmersmarket.getFloat("longitude");

    zone = mercatorMap.getScreenLocation(new PVector(lat, lon));

    //title
    fill(52, 152, 219); //blue
    rect(displayWidth*.75, displayHeight*.025, displayWidth*.5, displayHeight*.05);
    fill(0);
    textSize(45);
    fill(255);
    text("Chicago Farmer's Markets", displayWidth*.755, displayHeight*.025);

    textAlign(CENTER, CENTER);
    ellipseMode(CENTER);
    rectMode(CENTER);

    if ((dist(mouseX, mouseY, zone.x, zone.y)>25)) { 
      strokeWeight(3);
      fill (231, 76, 60, 85);//red
      arc(zone.x, zone.y, 50, 50, -PI, 0);
      arc(zone.x, zone.y, 50, 50, -PI, 180);
      ellipse (zone.x, zone.y, 3, 3);
    }
  }
  //created JSON object, knows its an array
  //println(json);
  //initialized objects here
  for (int i = 0; i < json.size (); i++) {

    JSONObject farmersmarket = json.getJSONObject(i);

    Float lat = farmersmarket.getFloat("latitude");

    Float lon = farmersmarket.getFloat("longitude");
    String location = farmersmarket.getString("intersection");

    String day = farmersmarket.getString("day");
    String start = farmersmarket.getString("start_time");
    String end = farmersmarket.getString("end_time");

    //println(location + " " + lon + ", " + lat);
    zone = mercatorMap.getScreenLocation(new PVector(lat, lon));
    //getting all of  the lat/lon in list and creating vector
    //location dots & color
    if ((dist(mouseX, mouseY, zone.x, zone.y)>25)) { 
      fill (231, 76, 60, 85); //red
      // ellipse (zone.x, zone.y, displayHeight/100, displayHeight/100);
    } else if (dist(mouseX, mouseY, zone.x, zone.y)<25) {
      noFill();
      //ellipse(zone.x, zone.y, displayHeight/40, displayHeight/40);
      pushStyle(); 
      strokeWeight(6);
      stroke(155, 89, 182); //purple
      arc(zone.x, zone.y, 30, 30, -PI, 0);
      arc(zone.x, zone.y, 30, 30, -PI, 180);
      popStyle();

      pushStyle();
      strokeWeight(6);
      //ellipse (zone.x, zone.y, displayHeight/60, displayHeight/60);
      stroke(41, 128, 185); //emerald green
      arc(zone.x, zone.y, 50, 50, -PI, 0);
      arc(zone.x, zone.y, 50, 50, -PI, 180);
      popStyle(); 
      fill(0);
      ellipse (zone.x, zone.y, 3, 3);
    } 


    if ((dist(mouseX, mouseY, zone.x, zone.y)<25) && mousePressed) {
      pushStyle();
      fill(0, 0, 0);
      textSize(40);
      //display day
      fill (52, 152, 219); //blue
      rect(zone.x, zone.y-120, 220, 100);
      fill(0); 
      text(day, zone.x, zone.y-120);

      popStyle();
    } else if (dist(mouseX, mouseY, zone.x, zone.y)<25) {
      pushStyle();
      fill(0, 0, 0);
      textSize(32);
      //display intersection location
      fill(155, 89, 182); //purple
      rect(zone.x, zone.y-120, 300, 100);
      fill(0);
      text(location, zone.x, zone.y-120, 300, 100);
      popStyle();

      //start and end times

      //start box
      pushStyle();
      fill(0, 0, 0);
      textSize(30);
      fill (39, 174, 96); //emerald green
      rect(zone.x-215, zone.y-145, 130, 50);
      fill(0); 
      text(start, zone.x-215, zone.y-145);
      popStyle();

      //end box
      pushStyle();
      fill(0, 0, 0);
      textSize(30);
      fill (231, 76, 60); //red
      rect(zone.x-215, zone.y-95, 130, 50);
      fill(0); 
      text(end, zone.x-215, zone.y-95);
      popStyle();

    }
  }
}

